# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::CompDecompressor Class Reference

Compress a frame component. More...

`#include <comp_decompress.h>`

Collaboration diagram for dirac::CompDecompressor:

[legend]
List of all members.

## Public Member Functions

- CompDecompressor (DecoderParams &decp, const FrameParams &fp)
    Constructor.
- void Decompress (ComponentByteIO *p_component_byteio, PicArray &pic_data)
    Decompress a frame component.

## Private Member Functions

- CompDecompressor (const CompDecompressor &cpy)
    Copy constructor is private and body-less.
- CompDecompressor & operator= (const CompDecompressor &rhs)
    Assignment = is private and body-less.
- void SetToVal (PicArray &pic_data, const Subband &node, ValueType val)
    Sets the data of a specific subband node to a given value.
- void SetupCodeBlocks (SubbandList &bands, const FrameSort fsort)
    Set up the code block structures for each subband.

## Private Attributes

- DecoderParams & m_decparams
    Copy of the decompression parameters provided to the constructor.
- const FrameParams & m_fparams
    Reference to the frame parameters provided to the constructor.

## Detailed Description

This class compresses one of the three components (Y, U, or V) of a frame according to a given set or parameters. CompCompressor is used by FrameCompressor..

## Constructor & Destructor Documentation

dirac::CompDecompressor::CompDecompressor | ( | DecoderParams & | decp,
|  | const FrameParams & | fp |
| ) |  |  |

Create and initialize a component decompressor with the given characteristics.

Parameters:

  | decp | decoding parameters
  | fp | frame parameters

dirac::CompDecompressor::CompDecompressor | ( | const CompDecompressor & | cpy | ) | `[private]`

Copy constructor is private and body-less. This class should not be copied.

## Member Function Documentation

void dirac::CompDecompressor::Decompress | ( | ComponentByteIO * | p_component_byteio,
|  | PicArray & | pic_data |
| ) |  |  |

Decompress a PicArray containing a frame component (Y, U, or V).

Parameters:

  | p_component_byteio | Bytestream of component data
  | pic_data | contains the component data to be decompressed

CompDecompressor& dirac::CompDecompressor::operator= | ( | const CompDecompressor & | rhs | ) | `[private]`

Assignment = is private and body-less. This class should not be assigned.

void dirac::CompDecompressor::SetToVal | ( | PicArray & | pic_data,
|  | const Subband & | node,
|  | ValueType | val |
| ) |  |  | `[private]`

Sets the data of a specific subband node to a given value

Parameters:

  | pic_data | contains the component data
  | node | subband node
  | val | the value to set

void dirac::CompDecompressor::SetupCodeBlocks | ( | SubbandList & | bands,
|  | const FrameSort | fsort |
| ) |  |  | `[private]`

Set up the code block structures for each subband

Parameters:

  | bands | the set of all the subbands
  | fsort | the frame sort - I, L1 or L2

## Member Data Documentation

DecoderParams& dirac::CompDecompressor::m_decparams`[private]`

const FrameParams& dirac::CompDecompressor::m_fparams`[private]`

The documentation for this class was generated from the following file:

- comp_decompress.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.